Index: lib/libnetgraph/sock.c
===================================================================
--- lib/libnetgraph/sock.c	(revision 259250)
+++ lib/libnetgraph/sock.c	(working copy)
@@ -111,8 +111,11 @@
 		/* Save node name */
 		strlcpy(namebuf, name, sizeof(namebuf));
 	} else if (dsp != NULL) {
-		u_char rbuf[sizeof(struct ng_mesg) + sizeof(struct nodeinfo)];
-		struct ng_mesg *const resp = (struct ng_mesg *) rbuf;
+		union {
+			u_char rbuf[sizeof(struct ng_mesg) + sizeof(struct nodeinfo)];
+			struct ng_mesg res;
+		} res;
+		struct ng_mesg *const resp = (struct ng_mesg *) res.rbuf;
 		struct nodeinfo *const ni = (struct nodeinfo *) resp->data;
 
 		/* Find out the node ID */
@@ -123,7 +126,7 @@
 				NGLOG("send nodeinfo");
 			goto errout;
 		}
-		if (NgRecvMsg(cs, resp, sizeof(rbuf), NULL) < 0) {
+		if (NgRecvMsg(cs, resp, sizeof(res.rbuf), NULL) < 0) {
 			errnosv = errno;
 			if (_gNgDebugLevel >= 1)
 				NGLOG("recv nodeinfo");
